Unit AFT0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AM12R_p, AM13R_p;

procedure AFT0R(var A :Array of Real; var B :Array of Real; var Z :Array of Real;
                 N :Integer; M :Integer; var IERR :Integer);

implementation

procedure AFT0R(var A :Array of Real; var B :Array of Real; var Z :Array of Real;
                 N :Integer; M :Integer; var IERR :Integer);
var
I,J,M1,LB,L,ITER,M2,LOR1,MORN,K,K1,K2,K3,KM1,L1 :Integer;
T,V1,A10,A21,A34,B11,B34,OLD1,BNORM,U1,V2,A11,A22,A43,B12,B44,EPSA,OLD2,CONST_,U2,V3,A12,A30,A44,B22,EPS,EPSB,U3,ANI,A20,A33,BNI,B33,ANORM :Real;
WANTX,MID :Boolean;
const
OT116 :Real = 1.1605;
ZERO :Real = 0.;
ONE :Real = 1.;
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20,_21,_22;
begin
IERR := 0;
EPS := SYS051;
WANTX := False;
if ( M = 0 ) 
 then WANTX := True;
ANORM := ZERO;
BNORM := ZERO;
for I:=1 to N do
 begin
  ANI := ZERO;
  if ( I <> 1 ) 
   then ANI := Abs(A[(I-1)+(I-1-1)*N]);
  BNI := ZERO;
  for J:=I to N do
   begin
    ANI := ANI+Abs(A[(I-1)+(J-1)*N]);
    BNI := BNI+Abs(B[(I-1)+(J-1)*N]);
_1:
   end;
  if ( ANI > ANORM )
   then ANORM := ANI;
  if ( BNI > BNORM ) 
   then BNORM := BNI;
_2:
 end;
if ( ANORM = ZERO ) 
 then ANORM := EPS;
if ( BNORM = ZERO ) 
 then BNORM := EPS;
EPSA := EPS*ANORM;
EPSB := EPS*BNORM;
M1 := N;
ITER := 0;
_3:
if ( M1 <= 2 ) 
 then goto _22;
for LB:=1 to M1 do
 begin
  L := M1+1-LB;
  if ( L = 1 )
   then goto _6;
  if ( Abs(A[(L-1)+(L-1-1)*N]) <= EPSA )
   then goto _5;
_4:
 end;
_5:
A[(L-1)+(L-1-1)*N] := ZERO;
if ( L < M1-1 )
 then goto _6;
M1 := L-1;
ITER := 0;
goto _3;
_6:
if ( Abs(B[(L-1)+(L-1)*N]) > EPSB )
 then goto _9;
B[(L-1)+(L-1)*N] := ZERO;
L1 := L+1;
AM12R(A[(L-1)+(L-1)*N],A[(L1-1)+(L-1)*N],U1,U2,V1,V2);
if ( U1 <> ONE ) 
 then goto _8;
for J:=L to N do
 begin
  T := A[(L-1)+(J-1)*N]+U2*A[(L1-1)+(J-1)*N];
  A[(L-1)+(J-1)*N] := A[(L-1)+(J-1)*N]+T*V1;
  A[(L1-1)+(J-1)*N] := A[(L1-1)+(J-1)*N]+T*V2;
  T := B[(L-1)+(J-1)*N]+U2*B[(L1-1)+(J-1)*N];
  B[(L-1)+(J-1)*N] := B[(L-1)+(J-1)*N]+T*V1;
  B[(L1-1)+(J-1)*N] := B[(L1-1)+(J-1)*N]+T*V2;
_7:
 end;
_8:
L := L1;
goto _5;
_9:
M2 := M1-1;
L1 := L+1;
CONST_ := 0.75;
ITER := ITER+1;
if ( ITER = 1 )
 then goto _10;
if ( Abs(A[(M1-1)+(M1-1-1)*N]) < CONST_*OLD1 ) 
 then goto _10;
if ( Abs(A[(M1-1-1)+(M1-2-1)*N]) < CONST_*OLD2 ) 
 then goto _10;
if ( ITER = 10 ) 
 then goto _11;
if ( ITER > 30 ) 
 then goto _21;
_10:
B11 := B[(L-1)+(L-1)*N];
B22 := B[(L1-1)+(L1-1)*N];
if ( Abs(B22) < EPSB ) 
 then B22 := EPSB;
B33 := B[(M2-1)+(M2-1)*N];
if ( Abs(B33) < EPSB ) 
 then B33 := EPSB;
B44 := B[(M1-1)+(M1-1)*N];
if ( Abs(B44) < EPSB ) 
 then B44 := EPSB;
A11 := A[(L-1)+(L-1)*N]/B11;
A12 := A[(L-1)+(L1-1)*N]/B22;
A21 := A[(L1-1)+(L-1)*N]/B11;
A22 := A[(L1-1)+(L1-1)*N]/B22;
A33 := A[(M2-1)+(M2-1)*N]/B33;
A34 := A[(M2-1)+(M1-1)*N]/B44;
A43 := A[(M1-1)+(M2-1)*N]/B33;
A44 := A[(M1-1)+(M1-1)*N]/B44;
B12 := B[(L-1)+(L1-1)*N]/B22;
B34 := B[(M2-1)+(M1-1)*N]/B44;
A10 := ((A33-A11)*(A44-A11)-A34*A43+A43*B34*A11)/A21+A12-
A11*B12;
A20 := (A22-A11-A21*B12)-(A33-A11)-(A44-A11)+A43*B34;
A30 := A[(L+2-1)+(L1-1)*N]/B22;
goto _12;
_11:
A10 := ZERO;
A20 := ONE;
A30 := OT116;
_12:
OLD1 := Abs(A[(M1-1)+(M1-1-1)*N]);
OLD2 := Abs(A[(M1-1-1)+(M1-2-1)*N]);
if ( not WANTX ) 
 then LOR1 := L;
if ( WANTX )
 then LOR1 := 1;
if ( not WANTX ) 
 then MORN := M1;
if ( WANTX ) 
 then MORN := N;
for K:=L to M2 do
 begin
  MID := K <> M2;
  K1 := K+1;
  K2 := K+2;
  K3 := K+3;
  if ( K3 > M1 ) 
   then K3 := M1;
  KM1 := K-1;
  if ( KM1 < L ) 
   then KM1 := L;
  if ( K = L )
   then AM13R(A10,A20,A30,U1,U2,U3,V1,V2,V3);
  if ( K > L) and (K < M2 )
   then AM13R(A[(K-1)+(KM1-1)*N],A[(K1-1)+(KM1-1)*N],
        A[(K2-1)+(KM1-1)*N],U1,U2,U3,V1,V2,V3);
  if ( K = M2 )
   then AM12R(A[(K-1)+(KM1-1)*N],A[(K1-1)+(KM1-1)*N],U1,U2,V1,V2);
  if ( U1 <> ONE ) 
   then goto _14;
  for J:=KM1 to MORN do
   begin
    T := A[(K-1)+(J-1)*N]+U2*A[(K1-1)+(J-1)*N];
    if ( MID ) 
     then T := T+U3*A[(K2-1)+(J-1)*N];
    A[(K-1)+(J-1)*N] := A[(K-1)+(J-1)*N]+T*V1;
    A[(K1-1)+(J-1)*N] := A[(K1-1)+(J-1)*N]+T*V2;
    if ( MID ) 
     then A[(K2-1)+(J-1)*N] := A[(K2-1)+(J-1)*N]+T*V3;
    T := B[(K-1)+(J-1)*N]+U2*B[(K1-1)+(J-1)*N];
    if ( MID ) 
     then T := T+U3*B[(K2-1)+(J-1)*N];
    B[(K-1)+(J-1)*N] := B[(K-1)+(J-1)*N]+T*V1;
    B[(K1-1)+(J-1)*N] := B[(K1-1)+(J-1)*N]+T*V2;
    if ( MID ) 
     then B[(K2-1)+(J-1)*N] := B[(K2-1)+(J-1)*N]+T*V3;
_13:
   end;
  if ( K = L ) 
   then goto _14;
  A[(K1-1)+(K-1-1)*N] := ZERO;
  if ( MID ) 
   then A[(K2-1)+(K-1-1)*N] := ZERO;
_14:
  if ( K = M2 ) 
   then goto _17;
  AM13R(B[(K2-1)+(K2-1)*N],B[(K2-1)+(K1-1)*N],B[(K2-1)+(K-1)*N],U1,U2,U3,V1,V2,
  V3);
  if ( U1 <> ONE ) 
   then goto _17;
  for I:=LOR1 to K3 do
   begin
    T := A[(I-1)+(K2-1)*N]+U2*A[(I-1)+(K1-1)*N]+U3*A[(I-1)+(K-1)*N];
    A[(I-1)+(K2-1)*N] := A[(I-1)+(K2-1)*N]+T*V1;
    A[(I-1)+(K1-1)*N] := A[(I-1)+(K1-1)*N]+T*V2;
    A[(I-1)+(K-1)*N] := A[(I-1)+(K-1)*N]+T*V3;
    T := B[(I-1)+(K2-1)*N]+U2*B[(I-1)+(K1-1)*N]+U3*B[(I-1)+(K-1)*N];
    B[(I-1)+(K2-1)*N] := B[(I-1)+(K2-1)*N]+T*V1;
    B[(I-1)+(K1-1)*N] := B[(I-1)+(K1-1)*N]+T*V2;
    B[(I-1)+(K-1)*N] := B[(I-1)+(K-1)*N]+T*V3;
_15:
   end;
  B[(K2-1)+(K-1)*N] := ZERO;
  B[(K2-1)+(K1-1)*N] := ZERO;
  if ( not WANTX ) 
   then goto _17;
  for I:=1 to N do
   begin
    T := Z[(I-1)+(K2-1)*N]+U2*Z[(I-1)+(K1-1)*N]+U3*Z[(I-1)+(K-1)*N];
    Z[(I-1)+(K2-1)*N] := Z[(I-1)+(K2-1)*N]+T*V1;
    Z[(I-1)+(K1-1)*N] := Z[(I-1)+(K1-1)*N]+T*V2;
    Z[(I-1)+(K-1)*N] := Z[(I-1)+(K-1)*N]+T*V3;
_16:
   end;
_17:
  AM12R(B[(K1-1)+(K1-1)*N],B[(K1-1)+(K-1)*N],U1,U2,V1,V2);
  if ( U1 <> ONE ) 
   then goto _20;
  for I:=LOR1 to K3 do
   begin
    T := A[(I-1)+(K1-1)*N]+U2*A[(I-1)+(K-1)*N];
    A[(I-1)+(K1-1)*N] := A[(I-1)+(K1-1)*N]+T*V1;
    A[(I-1)+(K-1)*N] := A[(I-1)+(K-1)*N]+T*V2;
    T := B[(I-1)+(K1-1)*N]+U2*B[(I-1)+(K-1)*N];
    B[(I-1)+(K1-1)*N] := B[(I-1)+(K1-1)*N]+T*V1;
    B[(I-1)+(K-1)*N] := B[(I-1)+(K-1)*N]+T*V2;
_18:
   end;
  B[(K1-1)+(K-1)*N] := ZERO;
  if ( not WANTX ) 
   then goto _20;
  for I:=1 to N do
   begin
    T := Z[(I-1)+(K1-1)*N]+U2*Z[(I-1)+(K-1)*N];
    Z[(I-1)+(K1-1)*N] := Z[(I-1)+(K1-1)*N]+T*V1;
    Z[(I-1)+(K-1)*N] := Z[(I-1)+(K-1)*N]+T*V2;
_19:
   end;
_20:
 end;
goto _3;
_21:
IERR := 128+M1;
_22:
end;

end.
