Unit AGT1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFT0R_p, AM12R_p, AM12C_p, UTAG10_p;

procedure AGT1R(var A :Array of Real; var B :Array of Real;
                var ALFR :Array of Real; var ALFI :Array of Real;
                var BETA :Array of Real; N :Integer;
                var IERR :Integer);

implementation

procedure AGT1R(var A :Array of Real; var B :Array of Real;
                var ALFR :Array of Real; var ALFI :Array of Real;
                var BETA :Array of Real; N :Integer;
                var IERR :Integer);
var
M,L,I,J :Integer;
EPS,EPSB,BNORM,BNI,U1,U2,V1,V2,F,AN,A11,A12,A21,A22,A11R,A11I,A12R,
   A12I,A21R,A21I,A22R,A22I,BN,B11,B12,B22,E,C,D,T,ER,EI,CZ,SZR,CQ,
   SQR,SQI,SSR,SSI,TR,TI,BDR,BDI,R,SZI :Real;
FLIP :Boolean;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
HALF :Real = 0.5;
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
EPS := SYS051;
IERR := 0;
AFT0R(A,B,A,N,1,IERR);
BNORM := ZERO;
for I:=1 to N do
 begin
  BNI := ZERO;
  for J:=1 to N do
   begin
    BNI := BNI+Abs(B[(I-1)+(J-1)*N]);
_1:
   end;
  if ( BNI > BNORM ) 
   then BNORM := BNI;
_2:
 end;
if ( BNORM = ZERO ) 
 then BNORM := EPS;
EPSB := EPS*BNORM;
M := N;
_3:
if ( M = 1 ) 
 then goto _4;
if ( A[(M-1)+(M-2)*N] <> ZERO ) 
 then goto _5;
_4:
ALFR[M-1] := A[(M-1)+(M-1)*N];
if ( B[(M-1)+(M-1)*N] < ZERO ) 
 then ALFR[M-1] := -ALFR[M-1];
BETA[M-1] := Abs(B[(M-1)+(M-1)*N]);
ALFI[M-1] := ZERO;
M := M-1;
goto _15;
_5:
L := M-1;
if ( Abs(B[(L-1)+(L-1)*N]) > EPSB ) 
 then goto _6;
B[(L-1)+(L-1)*N] := ZERO;
AM12R(A[(L-1)+(L-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
goto _11;
_6:
if ( Abs(B[(M-1)+(M-1)*N]) > EPSB ) 
 then goto _7;
B[(M-1)+(M-1)*N] := ZERO;
AM12R(A[(M-1)+(M-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
BN := ZERO;
goto _8;
_7:
AN := Abs(A[(L-1)+(L-1)*N])+Abs(A[(L-1)+(M-1)*N])+Abs(A[(M-1)+(L-1)*N])+Abs(A[(M-1)+(M-1)*N]);
BN := Abs(B[(L-1)+(L-1)*N])+Abs(B[(L-1)+(M-1)*N])+Abs(B[(M-1)+(M-1)*N]);
F := ONE/AN;
A11 := A[(L-1)+(L-1)*N]*F;
A12 := A[(L-1)+(M-1)*N]*F;
A21 := A[(M-1)+(L-1)*N]*F;
A22 := A[(M-1)+(M-1)*N]*F;
F := ONE/BN;
B11 := B[(L-1)+(L-1)*N]*F;
B12 := B[(L-1)+(M-1)*N]*F;
B22 := B[(M-1)+(M-1)*N]*F;
E := A11/B11;
C := ((A22-E*B22)/B22-(A21*B12)/(B11*B22))*HALF;
D := C*C+(A21*(A12-E*B12))/(B11*B22);
if ( D < ZERO ) 
 then goto _14;
if ( C >= ZERO ) 
 then E := E+(C+Sqrt(D));
if ( C < ZERO ) 
 then E := E+(C-Sqrt(D));
A11 := A11-E*B11;
A12 := A12-E*B12;
A22 := A22-E*B22;
FLIP := ( (Abs(A11)+Abs(A12)) >= (Abs(A21)+Abs(A22)) );
if ( FLIP ) 
 then AM12R(A12,A11,U1,U2,V1,V2);
if ( not FLIP ) 
 then AM12R(A22,A21,U1,U2,V1,V2);
_8:
if ( U1 <> ONE ) 
 then goto _10;
for I:=1 to M do
 begin
  T := A[(I-1)+(M-1)*N]+U2*A[(I-1)+(L-1)*N];
  A[(I-1)+(M-1)*N] := A[(I-1)+(M-1)*N]+V1*T;
  A[(I-1)+(L-1)*N] := A[(I-1)+(L-1)*N]+V2*T;
  T := B[(I-1)+(M-1)*N]+U2*B[(I-1)+(L-1)*N];
  B[(I-1)+(M-1)*N] := B[(I-1)+(M-1)*N]+V1*T;
  B[(I-1)+(L-1)*N] := B[(I-1)+(L-1)*N]+V2*T;
_9:
 end;
_10:
if ( BN = ZERO ) 
 then goto _13;
FLIP := ( AN >= Abs(E)*BN );
if ( FLIP ) 
 then AM12R(B[(L-1)+(L-1)*N],B[(M-1)+(L-1)*N],U1,U2,V1,V2);
if ( not FLIP ) 
 then AM12R(A[(L-1)+(L-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
_11:
if ( U1 <> ONE ) 
 then goto _13;
for J:=L to N do
 begin
  T := A[(L-1)+(J-1)*N]+U2*A[(M-1)+(J-1)*N];
  A[(L-1)+(J-1)*N] := A[(L-1)+(J-1)*N]+V1*T;
  A[(M-1)+(J-1)*N] := A[(M-1)+(J-1)*N]+V2*T;
  T := B[(L-1)+(J-1)*N]+U2*B[(M-1)+(J-1)*N];
  B[(L-1)+(J-1)*N] := B[(L-1)+(J-1)*N]+V1*T;
  B[(M-1)+(J-1)*N] := B[(M-1)+(J-1)*N]+V2*T;
_12:
 end;
_13:
A[(M-1)+(L-1)*N] := ZERO;
B[(M-1)+(L-1)*N] := ZERO;
ALFR[L-1] := A[(L-1)+(L-1)*N];
ALFR[M-1] := A[(M-1)+(M-1)*N];
if ( B[(L-1)+(L-1)*N] < ZERO ) 
 then ALFR[L-1] := -ALFR[L-1];
if ( B[(M-1)+(M-1)*N] < ZERO ) 
 then ALFR[M-1] := -ALFR[M-1];
BETA[L-1] := Abs(B[(L-1)+(L-1)*N]);
BETA[M-1] := Abs(B[(M-1)+(M-1)*N]);
ALFI[M-1] := ZERO;
ALFI[L-1] := ZERO;
M := M-2;
goto _15;
_14:
ER := E+C;
EI := Sqrt(-D);
A11R := A11-ER*B11;
A11I := EI*B11;
A12R := A12-ER*B12;
A12I := EI*B12;
A21R := A21;
A21I := ZERO;
A22R := A22-ER*B22;
A22I := EI*B22;
FLIP := ( (Abs(A11R)+Abs(A11I)+Abs(A12R)+Abs(A12I))
    >= (Abs(A21R)+Abs(A22R)+Abs(A22I)) );
if ( FLIP ) 
 then AM12C(A12R,A12I,-A11R,-A11I,CZ,SZR,SZI);
if ( not FLIP ) 
 then AM12C(A22R,A22I,-A21R,-A21I,CZ,SZR,SZI);
FLIP := ( AN >= (Abs(ER)+Abs(EI))*BN );
if ( FLIP ) 
 then AM12C(CZ*B11+SZR*B12,SZI*B12,SZR*B22,
SZI*B22,CQ,SQR,SQI);
if ( not FLIP ) 
 then AM12C(CZ*A11+SZR*A12, SZI*A12,CZ*
A21+SZR*A22, SZI*A22,CQ,SQR,SQI);
SSR := SQR*SZR+SQI*SZI;
SSI := SQR*SZI-SQI*SZR;
TR := CQ*CZ*A11+CQ*SZR*A12+SQR*CZ*A21+SSR*A22;
TI := CQ*SZI*A12-SQI*CZ*A21+SSI*A22;
BDR := CQ*CZ*B11+CQ*SZR*B12+SSR*B22;
BDI := CQ*SZI*B12+SSI*B22;
R := Sqrt(BDR*BDR+BDI*BDI);
BETA[L-1] := BN*R;
ALFR[L-1] := AN*(TR*BDR+TI*BDI)/R;
ALFI[L-1] := AN*(TR*BDI-TI*BDR)/R;
TR := SSR*A11-SQR*CZ*A12-CQ*SZR*A21+CQ*CZ*A22;
TI := -SSI*A11-SQI*CZ*A12+CQ*SZI*A21;
BDR := SSR*B11-SQR*CZ*B12+CQ*CZ*B22;
BDI := -SSI*B11-SQI*CZ*B12;
R := Sqrt(BDR*BDR+BDI*BDI);
BETA[M-1] := BN*R;
ALFR[M-1] := AN*(TR*BDR+TI*BDI)/R;
ALFI[M-1] := AN*(TR*BDI-TI*BDR)/R;
M := M-2;
_15:
if ( M > 0 ) 
 then goto _3;
if ( IERR <> 0 ) 
 then UTAG10(IERR,42);
end;

end.
