Unit AM12C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM12C(AJR :Real; AJI :Real; AJP1R :Real; AJP1I :Real;
                var C :Real; var SR :Real; var SI :Real);

implementation

procedure AM12C(AJR :Real; AJI :Real; AJP1R :Real; AJP1I :Real;
                var C :Real; var SR :Real; var SI :Real);
var
R :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2,_3;
begin
if ( AJP1R = ZERO ) and ( AJP1I = ZERO ) 
 then goto _1;
if ( AJR = ZERO ) and ( AJI = ZERO ) 
 then goto _2;
R := Sqrt(AJR*AJR+AJI*AJI);
C := R;
SR := (AJR*AJP1R+AJI*AJP1I)/R;
SI := (AJR*AJP1I-AJI*AJP1R)/R;
R := ONE/Sqrt(C*C+SR*SR+SI*SI);
C := C*R;
SR := SR*R;
SI := SI*R;
goto _3;
_1:
C := ONE;
SR := ZERO;
SI := ZERO;
goto _3;
_2:
C := ZERO;
SR := ONE;
SI := ZERO;
_3:
end;

end.
