Unit AM13R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM13R(AJ :Real; AJP1 :Real; AJP2 :Real; var UJ :Real;
                var UJP1 :Real; var UJP2 :Real; var VJ :Real;
                var VJP1 :Real; var VJP2 :Real);

implementation

procedure AM13R(AJ :Real; AJP1 :Real; AJP2 :Real; var UJ :Real;
                var UJP1 :Real; var UJP2 :Real; var VJ :Real;
                var VJP1 :Real; var VJP2 :Real);
var
S,RD,R :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2;
begin
if ( AJP1 = ZERO ) and ( AJP2 = ZERO ) 
 then goto _1;
S := Abs(AJ)+Abs(AJP1)+Abs(AJP2);
RD := ONE/S;
UJ := AJ*RD;
UJP1 := AJP1*RD;
UJP2 := AJP2*RD;
R := Sqrt(UJ*UJ+UJP1*UJP1+UJP2*UJP2);
if ( UJ < ZERO ) 
 then R := -R;
RD := ONE/R;
VJ := -(UJ+R)*RD;
VJP1 := -UJP1*RD;
VJP2 := -UJP2*RD;
UJ := ONE;
UJP1 := VJP1/VJ;
UJP2 := VJP2/VJ;
goto _2;
_1:
UJ := ZERO;
_2:
end;

end.
